"""
 An instance of this class is an e-mail message
 
Copyright 2003 Graham King

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
"""

class MailMessage:

	def __init__(self, idParam, dateParam, titleParam, fromAddressParam, toAddressParam, bodyParam, ccAddressParam = '', rawParam=''):

		# The id as issued by the POP3 server
		self.id = idParam 

		self.date = dateParam
		self.title = titleParam 
		self.fromAddress = fromAddressParam 
		self.toAddress = toAddressParam
		self.body = bodyParam

		self.ccAddress = ccAddressParam

		# raw is the message as sent, with all the headers
		self.raw = rawParam

		# Display fields

		self.fromAddressDisplay = self.filtered(self.fromAddress)
		self.toAddressDisplay = self.filtered(self.toAddress)
		self.ccAddressDisplay = self.filtered(self.ccAddress)

		self.fromAddressShort = self.shortAddress( self.fromAddress )

	def __str__(self):

		result = "Id: "+ str(self.id)
		result += ", date: "+ self.date 
		result += ", title: "+ self.title 
		result += ", from: "+ self.fromAddress 
		result += ", to: "+ self.toAddress 
		result += ", body: "+ self.body

		return result

	def filtered(self, string):

		return string.replace("<", "&lt;").replace(">", "&gt;")

	def shortAddress(self, address):

		addressParts = address.split("<")

		if len(addressParts) == 1:
			return addressParts[0]
		else:

			name = addressParts[0].strip()
			email = addressParts[1].strip()

			if len(name) > 0:
				return name
			else:
				return email.replace(">", "") # We lost the '<' in the split, now lose the '>'


