#!/usr/bin/python2

"""
Write an e-mail. This is used both to compose a virgin mail and to reply to an existing one. We know which case we are in depending on the presence or not of an 'id' url parameter.

Copyright 2003 Graham King

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
"""

import mailUtils
import cgi
import sys

def formHTML(toParam='', ccParam='', subjectParam='', bodyParam=''):

	result = ""


	result += "<form action=\"mailSend.py\" method=\"post\" enctype=\"multipart/form-data\" >\n"
	result += "<table>\n"

	# From
	result += "<tr><td>From:</td>"
	result += "<td><input type=text name=fromAddress value=\""+ mailUtils.defaultFromAddress +"\"></td>"

	# Attachment upload
	result += "<td rowspan=2 valign=top>\n"
	result += "<input type=file name=\"attachment\"><input type=submit name=\"attach\" value=\"Attach file\"><br>\n"
	result += "<small><i>Attach all files BEFORE filling in any of the rest</i></small>\n"
	result += "</td>\n"
	result += "</tr>\n"
	
	# To
	result += "<tr><td>To:</td>"
	result += "<td><input type=text name=toAddress value=\""+ toParam +"\"></td>"
	result += "<small>(For multiple addresses in To or CC separate them with commas)</small></tr>\n"

	# Cc
	result += "<tr><td>Cc:</td>"
	result += "<td><input type=text name=ccAddress value=\""+ ccParam +"\"></td>\n"

	# Current attachment list
	result += "<td rowspan=2>\n"
	result += "Current attachments <small>(if any)</small>:<br>\n"
	for (name, url, path) in mailUtils.attachmentsList():

		result += "<a href=\""+ url +"\">"+ name +"</a>"
		result += "<small>(<a href=\"attachmentDelete.py?name="+ name +"\">del</a>)</small><br>\n"

	result += "</td>\n"
	result += "</tr>\n"

	# Subject
	result += "<tr><td>Subject:</td>"
	result += "<td><input type=text name=subject value=\""+ subjectParam +"\"></td></tr>\n"

	# Body
	result += "<tr><td>Body</td>"
	result += "<td colspan=2><textarea rows=25 cols=80 name=body>"+ bodyParam +"</textarea></td></tr>\n"
	result += "<tr><td><input type=submit name=\"send\" value=\"Send\"></td><td>&nbsp;</td></tr>\n"
	result += "</table>\n"
	result += "</form>\n"

	return result

# Prefixes every line of the string with a specific character (mailUtils.prefixChar)

def prefix(string):

	return '\n\n\n' + string.replace("\n", "\n"+ mailUtils.prefixChar +" ")


"""
Takes a comma separated string of addresses and returns the same string minus 
the elements that contains the senders address (mailUtils.defaultFromAddress)
"""
def allExceptOwner(addresses):

	initialAddressArray = addresses.split(',')
	finalAddressArray = []

	for element in initialAddressArray:

		# If this elements doesn't contain the owners address then keep it
		if element.find(mailUtils.defaultFromAddress) == -1 :
			finalAddressArray.append(element)

	return ', '.join(finalAddressArray)

# Ensures that 'key' (a string) is present on 'form' (of type cgi.FieldStorage). Prints a message to stdout, closes the HTML and quits if not present. Returns silenty if present.
def ensurePresent(form, key):

	if not form.has_key(key):
		print "'"+ key +"' URL parameter required"
		print mailUtils.footerHTML()
		sys.exit(0)

#
# Main
#

form = cgi.FieldStorage()

print mailUtils.headerHTML()
print mailUtils.toolbarHTML()
print 


ensurePresent(form, "type")

type = form["type"].value

if type == "new":

	print formHTML()

else:

	ensurePresent(form, "id")

	messageId = form["id"].value
	messageList = mailUtils.load()
	message = mailUtils.findMessage(messageList, messageId)

	if type == "reply" or type == "replyall":

		toField = message.fromAddress
		ccField = ""

		if type == "replyall": 
			toField += ", "+ allExceptOwner(message.toAddress)
			ccField = message.ccAddress

		if not (message.title.startswith("Re: ") or \
			message.title.startswith("RE: ") ):

			subjectField = "Re: "+ message.title
		else:
			subjectField = message.title

		bodyField = prefix(message.body)
	
		print formHTML(toField, ccField, subjectField, bodyField)

	elif type == "forward":

		subjectField = "Fwd: "+ message.title

		print formHTML('', '', subjectField, message.body)

	else:
		print "Invalid type. Must be [new|reply|replyall|forward]"


print mailUtils.footerHTML()

