#!/usr/bin/python2

"""
Sends an email (based on the url parameters given)

Copyright 2003 Graham King

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
"""

import cgi
import mailUtils
import smtplib
import base64
import cStringIO
from MimeWriter import MimeWriter
import mimetypes
import base64

# Attach a file

def attach(form):

	upload = form["attachment"]

	filename = upload.filename

	if (not upload.file) or (filename is None) or (len(filename) == 0):
		print "URL parameter 'attachment' must be a file you selected using the 'Browse...' picker. Please go back and try again.<br>\n"
		return

	fullpathname = mailUtils.attachmentsDirectory +"/"+ filename

	attachFile = open(fullpathname, "wb")
        attachFile.writelines( upload.file.readlines() )
        attachFile.close()

	print "Uploaded: "+ filename +"<br>"
	print "Click 'Compose' above to return to composing an e-mail<br>"

# Send the mail

def send(form):

	fromAddress = form["fromAddress"].value
	toAddress = form["toAddress"].value
	
	subject = form["subject"].value
	body = form["body"].value
	
	if form.has_key("ccAddress"):
		ccAddress = form["ccAddress"].value
	else:
		ccAddress = ''

	memFile = cStringIO.StringIO()
	message = MimeWriter(memFile)
	
	message.addheader("Subject", subject)
	message.addheader("From", fromAddress)
	message.addheader("To", toAddress)
	message.addheader("Cc", ccAddress)

	attachmentsList = mailUtils.attachmentsList()

	if len(attachmentsList) > 0:

		message.startmultipartbody("mixed")

		nextwriter = message.nextpart()

		nextwriter.addheader("Content-Transfer-Encoding", "7bit")
		mimefile = nextwriter.startbody("text/plain")
		mimefile.write( body )

		for (name, url, path) in attachmentsList:

			nextwriter = message.nextpart()
			(type, encoding) = mimetypes.guess_type(name)
			if type is None:
				type = "text/plain" 


			attachmentfile = open(path, "r")

			if type.startswith("text"):

				nextwriter.addheader("Content-Transfer-Encoding", "7bit")

				mimefile = nextwriter.startbody( type, [("name", name)] )
				mimefile.writelines( attachmentfile.readlines() )

			else:
				nextwriter.addheader("Content-Transfer-Encoding", "base64")
				nextwriter.addheader("Content-Disposition", "attachment")

				mimefile = nextwriter.startbody( type, [("name", name)] )

				base64.encode(attachmentfile, mimefile)

			attachmentfile.close()

			mailUtils.deleteAttachment(name)

		message.lastpart()
	
	else:
		mimefile = message.startbody("text/plain")
		mimefile.write( body )

	memFile.seek(0)
	data = ''.join( memFile.readlines() )

	toList = toAddress.split(',')
	toList.extend( ccAddress.split(',') )	## Cc has to be handled by the sender. Not part of SMTP
	
	server = smtplib.SMTP( mailUtils.smtpServer )
	
	if mailUtils.smtpRequiresAuthentication:
	
		# Login to server using AUTH LOGIN. 
		# The server supports other methods, which smtplib.login uses, but I get Authentication Failed. So hack it.
	
		(code, resp) = server.docmd("auth login")
	
		u64user = base64.encodestring(mailUtils.smtpUser)[:-1]
		(code, resp) = server.docmd(u64user)
	
		password = mailUtils.readPassword(mailUtils.smtpPasswordFile).strip()
		u64pwd = base64.encodestring(password)[:-1]
		(code, resp) = server.docmd(u64pwd)
	
		# This is what we SHOULD be doing but it don't seem to work
		# password = mailUtils.readPassword(mailUtils.smtpPasswordFile).strip()
		# server.login( mailUtils.smtpUser, password )
	
	
	refused = server.sendmail( fromAddress, toList, data)
	server.quit()

	memFile.close()

	print "Message sent<br>"
	
	""" # I'm not sure if this bit works correctly so don't worry the user unnecessarily
	if len(refused) > 0:
		print "There were errors on at least one of the addresses. You will get a bounce from the mail server with more detail"
	"""
	

#
# Main
# 
form = cgi.FieldStorage()

print mailUtils.headerHTML()
print mailUtils.toolbarHTML()


if form.has_key("attach") and form.has_key("attachment"):	# Attach a file
	attach(form)

elif form.has_key("send"):					# Send the e-mail
	send(form)

else:
	print "Incorrect submit, so I don't know what to do. Either key 'attach' or key 'send' must be one the URL. Please go back and click one of the buttons."

print mailUtils.footerHTML()

